#include "stroj_casu.h"

int main(int argc, char ** argv)
{
	static struct main_file tcp_in_parent_socket;
	static struct main_file tcp_out_parent_socket;
	static struct main_file serial_port;
	static struct main_file stdin_file;

	// Pripravime si Mainloop
	main_init();
	main_get_time();
	
	// Inicializujeme status
	state_init();

	// Forknute procesy nebudou zombies
	signal(SIGCHLD, SIG_IGN);

	// Otevreme potrebne komunikacni kanaly
	// TCP IN
	if ((tcp_in_parent_socket.fd = tcp_listen(TCP_PORT_IN)) == -1)
		die("Cannot initialize TCP in");
	tcp_in_parent_socket.read_handler = &tcp_accept_in;
	file_add(&tcp_in_parent_socket);
	// TCP OUT
	if ((tcp_out_parent_socket.fd = tcp_listen(TCP_PORT_OUT)) == -1)
		die("Cannot initialize TCP out");
	tcp_out_parent_socket.read_handler = &tcp_accept_out;
	file_add(&tcp_out_parent_socket);
	// Seriovy port
	if ((serial_port.fd = open(SERIAL_PORT, O_RDWR)) == -1)
		die("Cannot open serial port");
	serial_init(serial_port.fd);
	serial_port.read_handler = &serial_parse;
	file_add(&serial_port);
	// STDIN
	stdin_file.fd = 0;
	stdin_file.read_handler = &parse_command_line;
	file_add(&stdin_file);

	// A zacneme je poslouchat
	main_loop();

}
