void serial_init(int fd);
int serial_parse(struct main_file *fi);

void lcd_printf(char *fmt, ...);
#define lcd_display(msg) lcd_printf("%s", msg)
void updatemood(void);

struct hw {
	uns last_led_state;
	char lcd_display[SHORT_STRING];
	uns last_adc_l, last_adc_r;
} get_hw_state(void);
void set_hw_state(struct hw);

void lcd_write(char * msg);

#define LED(name, mask)							\
	void set_##name(int val)
LED(orange_led,		0x80);
LED(lamp,		0x10);
LED(green_led,		0x08);
LED(big_green_led,	0x04);
LED(big_yellow_led,	0x02);
LED(big_red_led,	0x01);
#undef LED

extern int state_left_sw, state_right_sw, state_black_button, state_red_button,
    state_lock, state_bell_button, state_magnet, state_big_red_sw, state_steam,
    state_antenna;

// Analog (0-255)
extern int state_tap, state_solar;

void set_left_meter(uns val);
void set_right_meter(uns val);

void setled_command(char * wtf);
void clrled_command(char * wtf);

void blinkled_command(char * wtf);
void unblinkled_command(char * wtf);

void init_blinking(void);
