#include <ucw/lib.h>
#include <ucw/mainloop.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <errno.h>
#include <pty.h>

#define 	SHORT_STRING		257
#define 	LONG_STRING		65537

#define		SERIAL_PORT		"/dev/ttyS0"

#define		MAX_TCP_CLIENTS		256
#define		TCP_EXPIRE_SEC		60	// 1min
#define		MAX_COMMANDS_PENDING	1024
// if the limit of pending commands is reached the hell timemachine doesn't
// accept any more but doesn't tell the user in any way

#define		TCP_PORT_IN		3109
#define		TCP_PORT_OUT		3119
//#define		TCP_ADDRESS		"10.0.0.166"

#define		LOG_TRIE_IN		1

#define		CISELNIK_EXPIRE_SEC	10	// 10sec

#define		MOVEDEST_TIMEOUT	100

typedef struct trie {
	struct trie * child[26];
	void *data;
} trie_t;

void listener_output_main(void);
void listener_input_main(void);
void fifo_parse(int signal);
int serial_input_parse(void);
#include "core_funcs.h"
#include "error.h"
#include "tcp_ip_funcs.h"
#include "serial_io.h"
#include "lang.h"
#include "admin_console.h"
#include "save_load.h"

extern char * commands_todo[MAX_COMMANDS_PENDING];
extern int commands_in_list;

extern struct main_file * tcp_output_files[MAX_TCP_CLIENTS];
extern int tcp_output_clients;

extern int mood;
extern int please_disgust;

extern plannedtask_t _plannedtasks[256]; // there shall not be more than 256 planned tasks
extern int _plannedtasks_n;
extern int _plannedtasks_current;

extern char ** _fortunefnames; // there shall not be more than 255 active fortune files
extern int _fortunefnames_n;

#define MOOD_MAX		256
#define MOOD_PLEASE_ADD		35
#define MOOD_NOPLEASE_SUB	11
#define MOOD_DISGUSTED		(MOOD_MAX /7)
#define MOOD_START		20

#define MEDIA_PLAYER	"mplayer"
#define	FORTUNE_BIN		"fortune"

//extern P_STATUS status;


#define stroj_now	((main_now) + (stroj_offset))
extern s64 stroj_offset;	// miliseconds since (or, if negative, to)
		// the Unix Epoch (1.1.1970.00:00 GMT)

#define PLANNED_TASKS_EXEC_THRESHOLD	500
//#define TCP_INPUT_DELAY	(128000/mood)	// in miliseconds
#define PLEASE_DISGUST_LIMIT	4
