#include "stroj_casu.h"

int tcp_listen(int port)
{
	// Oteviram TCP socket, na kterem chci poslouchat
	int tcp_socket;
	int s, on;
	
	tcp_socket = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (tcp_socket < 0)
		die("socket: %m");

	on = 1;
	s = setsockopt(tcp_socket, SOL_SOCKET, SO_REUSEADDR, (void *) &on, sizeof(on));

	struct sockaddr_in * addr;
	addr = xmalloc(sizeof(struct sockaddr_in));
	addr->sin_addr.s_addr = htonl(INADDR_ANY);	// zatim poslouchame vsude
	addr->sin_family = AF_INET;
	addr->sin_port = htons(port);

	if (bind(tcp_socket, (struct sockaddr *) addr, sizeof(struct sockaddr)) < 0)
		die("bind failed: %m");
	if (listen(tcp_socket, 5) < 0)
		die("listen failed: %m");
	// a vratime fd socketu
	return tcp_socket;
}

int tcp_accept_out(struct main_file *fi)
{
	// Prijimame prichozi spojeni na vystupnim portu
	int fd;
	struct sockaddr new_addr;
	struct main_file * file;
	socklen_t addrlen = sizeof(new_addr);
	fd = accept(fi->fd, &new_addr, &addrlen);
	if (!state_antenna) {close(fd); printf("Not connecting -- there is no antenna.\n"); return 0;}
	if (fd == -1) { msg(L_ERROR, "accept failed: %m"); return 0; }

	if (tcp_output_clients >= MAX_TCP_CLIENTS)
	{
		printf("Error -- too many connections\n");
		close(fd);
	}
	else
	{
		file = xmalloc_zero(sizeof(struct main_file));
		file->fd = fd;
		file->error_handler = &tcp_output_error;
		file->read_handler = &tcp_output_close;	// zavre se, pokud do nej neco zapisu
		tcp_output_files[tcp_output_clients] = file;
		file->data = xmalloc(sizeof(int));
		*((int *) file->data) = tcp_output_clients;
		file_add(file);
		tcp_output_clients++;
		
	}
	return 0;
}
int tcp_accept_in(struct main_file *fi)
{
	struct main_file *socket_watch;
	struct sockaddr new_addr;
	uns addrlen;
	addrlen = sizeof(new_addr);
	socket_watch = xmalloc_zero(sizeof(struct main_file));
	socket_watch->fd = accept(fi->fd, &new_addr, &addrlen);
	if (!state_antenna) {close(socket_watch->fd); xfree(socket_watch); printf("Not connecting -- there is no antenna.\n"); return 0;}
	if (socket_watch->fd == -1) printf("%d error opening\n",errno);
	socket_watch->read_handler = &tcp_input;
	socket_watch->error_handler = &tcp_input_error;
	file_add(socket_watch);
	file_set_timeout(socket_watch, main_now + TCP_EXPIRE_SEC*1000);

	return 0;
}

int tcp_input(struct main_file *fi)
{
/*	if ((fi->data != NULL) && (*((s64*) fi->data) + TCP_INPUT_DELAY > stroj_now))
		return 0;
	if (fi->data == NULL)
		fi->data = (void *) xmalloc(sizeof(s64));
	*((s64*) fi->data) = stroj_now;*/
	int real_length;
	char buf[LONG_STRING];
	char tajenka[24];
	real_length = read(fi->fd, buf,LONG_STRING);
	buf[real_length] = 0;
	file_set_timeout(fi, main_now + TCP_EXPIRE_SEC*1000);
	printf("read %s",buf);
	strncpy(tajenka, buf, 23);
	tajenka[23] = 0;
	if (strcmp(tajenka, "Au! laurie lantar lassi") == 0)
		tcp_output("Zakryjte to, co se nema zakryvat.\n");
	else if (strcmp(tajenka, "yeni unotime ve ramar a") == 0)
		tcp_output("Prepnete stroj do polohy \"More Magic\".\n");
	else if (strcmp(tajenka, "yeni ve linte yuldar av") == 0)
		tcp_output("Prilozte neco tam, kde nic neni.\n");
	else if (strcmp(tajenka, "mi oromardi lisse-miruv") == 0)
	  	tcp_output("Na tento vstup je nutno zadat prikaz pro presun,\naby bylo mozno spustit velkym cervenym tlacitkem presun.\nZiskejte prikaz pro presun.\n");
	else
	 	input_command(buf);
//	tcp_output(buf);
	return 0;
}

void tcp_input_error(struct main_file *fi, int cause)
{
	printf("input error\n");
	close(fi->fd);
	file_del(fi);
	xfree(fi);
}

void tcp_output_error(struct main_file *fi, int cause)
{
	printf("output error\n");
	tcp_output_close(fi);
}

int tcp_output_close(struct main_file *fi)
{
	write(fi->fd, "Bye!", 5);
	printf("output close\n");
	close(fi->fd);
	tcp_output_files[*((int *) fi->data)] = tcp_output_files[--tcp_output_clients];
	file_del(fi);
	xfree(fi);
	return 0;
}

void tcp_output(char * message)
{
	int i;
	for (i=0;i<tcp_output_clients;i++)
	{
		write(tcp_output_files[i]->fd, message, strlen(message));
	}
}

